  #define Version "20-01-2016"
 // 19-01-2016
 // test avec temperature congelmateur -22C ... BAD affichage en LONG
 // car NON sign et ne traite que du positif
 // modif pour afficher Temp DS12B20 en Flottant et LONG sign 3 decimales sur le LCD
 
 
 //#define Version "02-01-2016"
 // test OK  4MHz , 8MHz et 48MHz !

 
// Compiler :  MikroC For PIC Pro 6.62 registered version
// Oscillator:      HS-PLL 48.0000 MHz, 16.0000 MHz Crystal
// Ext. Modules:  LCD 2119 I2C.
// http://www.mikroe.com/forum/viewtopic.php?t=6020
//  sonde  DS18B20
//  Code ID identification 64 bits = B8031564C783FF28
// 0,0625 degrees C resolution

//
//  MCU:             PIC18F47J53
//  Dev.Board:       PIC clicker  MIKROE-1487   19$
//  Docu:
 #define Directory  "C:\_MikroC\_MesProjets_MikroC\_18F47J53_LCD_UART2_I2C2_DS18B20"
 #define Project "18F47J53_UART2_LCD_I2C2_LM335_ADC12b_DS18B20_2016.mcppi"
 #define With_UART2
 #define With_ADC12
 #define With_TMR1
 #define With LCD2119
 #define  LM335            // 2730mv at 0C , sinon c'est un LM35DZ 0mV at 0C
 #define OSCILLATEUR_INTERNE
// #define  TEST_FOSC
  #define With_DS18B20


 #define PROCESSOR 18F47J53
 #define POWER_SUPPLY_3_3V
 #define EXTRA_char    // for LCD2119
 
 #ifdef OSCILLATEUR_INTERNE
 #define FOSC 4.0  // MHz
 #define BAUD 9600  // UART2
 //P18F47J53_FOSC_interne_4MHz_No_PLL.cfgsch
 #else
 #define FOSC 48.0  // MHz   avec Q=16Mhz
 #define BAUD 115200  // UART2
// P18F47J53_Q16MHz_48MHz_w_PLL.cfgsch
 #endif

// Documentation :
 //      ac:DS_18F47J53
 //     ac:MCU_diagram
 //     ac:Click_Schema
 //     ac:Click_Board
 //     ac:Pins_Max_Voltage
 //     ac:QFN_Pinout
 //     ac:DS18B20_DS
 
//  #ifdef USB_Terminal
// test cordon Prolific PL2303H USB/TTL ... OK   sous WIN 10 PC ASUS
// avec driver 3.3.2.10 2008  COM12 RS232 Virtuel//
// Cordon PL2303  noir --- Gnd 0V
// Cordon PL2303  Vert --- RD5 TX
// Cordon PL2303  Blanc --- RD6 RX

// capteur de temperature DS18B20 au bout d'un cable
// http://daniel.menesplier.free.fr/Doc/BUS%201%20WIRE.pdf
//Ce circuits possde un code unique sur 64 bits comme tous les circuits 1 Wire.
// Le code famille est h"28", suivi de 6 octets propre au circuit et d'uno ctet de CRC.
// Si le circuit est seul sur le bus 1 Wire, la commande ROM peut tre
//  l'appel gnral SKIP ROM = h"CC".
// Une recherche pralable des 8 octets de code sera faite par la
//  commande READ ROM = h'33' si le circuit est seul

// Rouge .. +3,3V
// Blanc   Signal ---> PIC entree RE0  , R=2,7K  de tirage au + 3,3V
// Gris  .. 0V Gnd

// UART2
// ATTENTION , necessite 3 librairies
//_Lib_UART_c67.mcl" "
//_Lib_PPS_4xJ53.mcl" "
//_Lib_UART_Remappable.mcl"
// BAD exemple MIKROC :
// PPS_Mapping(15, _INPUT, _RX2_DT2);   // Sets pin 15 to be Input, and maps RX2/DT2 Input to it
// PPS_Mapping(5, _OUTPUT, _TX2_CK2);   // Sets pin 5 to be Output, and maps EUSART2 Asynchronous

// rajout Timer1 interrupt pour timming boucle principale sur 1 seconde

// Rajout LCD2119 en I2C2 sur portD D0 D1
// Rajout mesure Ana RA2 12 bits
// Affichage Raw et flotant en Volts
//#define Version "13-12-2015"

// config bit
/*
P18F47J53_FOSC_interne_8MHz_No_PLL.cfgsch
CONFIG1L : $1FFF8 : 0x0088
CONFIG1H : $1FFF9 : 0x00F7
CONFIG2L : $1FFFA : 0x00E8
CONFIG2H : $1FFFB : 0x00FF
CONFIG3L : $1FFFC : 0x00F3
CONFIG3H : $1FFFD : 0x00F9
CONFIG4L : $1FFFE : 0x00FF
CONFIG4H : $1FFFF : 0x00FB
 */
 
#include "built_in.h"     // for  Hi  Lo ..etc

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

#define With_UART2
#ifdef With_UART2
// redinition pour garder les memes habitudes !
#define UART2_Write UART_Remappable_Write
#define UART2_Write_Text UART_Remappable_Write_Text
#define UART2_Read  UART_Remappable_Read
#define UART2_Init UART_Remappable_Init
#define UART2_Tx_Idle  UART_Remappable_Tx_Idle
#endif

#define Device_LCD_ADR 0x74   // LCD 2119 adresse I2C du PCF8574
#define DS18B20   // OWS temp sensor

// -- Click 18F47J53  in definitions ----------
sbit LD1 at LATA0_bit;        // led + 4,7K !
sbit LD2 at LATA1_bit;        // led + 4,7K !
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;   //  tir au +5V via 10K
sbit T2 at RD2_bit;   //   tir au +5V via 10K
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

#define BP T1
#define BP1 T1
#define BP2 T2

sbit ANA_RA2 at PORTA.B2;
sbit ANA_RA2_Direction at TRISA2_bit;

sbit DS18B20_Sensor1  at PORTE.B0;
sbit DS18B20_Sensor1_Direction at TRISE.B0;


// globals
char TEXTE[120];
char CRam1[32];
char *txt;
char *p;

#ifdef With_UART2
#define MAXLEN2 128
volatile unsigned char buffer2[MAXLEN2] ;
volatile unsigned int Index2=0;
volatile unsigned int i2=0;  
volatile unsigned int UART2_DataReady=0;
volatile unsigned int Flag_data_OK ;
volatile unsigned char c2=0;
unsigned char *p2;
#endif
volatile unsigned int Flag_Timer0;
volatile unsigned int Flag_Timer1;
volatile unsigned int Cpt1;
char oldstate1 = 0, oldstate2 = 0;
unsigned char Example_State = 0;
char count;
unsigned int i,j,k,l;
unsigned int M;
int Etat;
unsigned char LCD_ADR;
signed long L1,L2;
unsigned long Freq;
float f1, f2 ;
unsigned int EA2, temp_res;
unsigned int Table_EA2[8];
unsigned int Nbval;
unsigned Somme_EA2;
static unsigned char c3,c4;

#ifdef DS18B20
#define DS18B20_1 &PORTE,0
const unsigned short TEMP_RESOLUTION = 12;
char *text = "000.00000";
char Tp[]="000.000000";
float Tf;
unsigned char  j0,j1, j2, j3, j4, j5, j6, j7, j8,j9 ;
unsigned char  tmp_sign,drp;
float res;
#endif

#ifdef USB_Terminal
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;
#endif

volatile struct chbits {   // 8 flags
     unsigned FrameErr:1;
     unsigned Over:1;
     unsigned Dialogue:1;
     unsigned FLT:1;
     unsigned PPS:1;
     unsigned Sommeil:1;
  //   unsigned Fill:1;
     unsigned Mesure:1;
     unsigned First_Run:1;
   }Drapeaux ;

#include "String_routines.h"
// BAD #include "Float_To_String_Routines.h"
#include "LCD2119_I2C2_routines.h"
/* pour memoire :
unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_Write_CGRAM_Chr(unsigned char cx)  ;
void LCD_Write_Chr(unsigned char cx) ;
void LCD_Write_Chr_at(int Ligne,int col,unsigned char c1);
void LCD_RAZ_Ligne( int L);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);
void LCD_display_date_Time(void);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);
*/

void InitTimer0(void);
unsigned char  UART2_Assign_To_PPS(void) ;
void Init_Hardware(void);
void CRLF2(void);
void UART2_Write_CText(const char *txt);
unsigned char  UART2_Assign_To_PPS(void);
void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char * Mesure_Temper_DS18B20(void);
char * SignedLong32bits_to_Ascii_3Decimales( signed long L1);
// +99.99  -99.99
char * Virgule2Asc_2decim(float ChiffreDeci);

// ISR
void interrupt() iv 0x0008 ics ICS_AUTO
{      
  static i2=0;
  if (TMR0IF_bit)
  {
   TXREG2='?';
   TMR0IF_bit=0;
  }
  if(RC2IF_bit==1) // && (RC2IE_bit==1))
    {
       c2 = RCREG2 ; //UART2_Read();
      if(OERR_bit)  //  RCSTA2.B1 OERR de RCSTA2
      {
          TXREG2='@';
         CREN2_bit = 0;
         _asm nop;
         CREN2_bit = 1;
         _asm nop;
      }
      while(FERR2_bit)
      {
        TXREG2='*';
        RCREG2=0;
        _asm nop;
         c2 = RCREG2;// UART2_Read(); //c2 = RCREG2;
        // The FERR bit can be forced clear by clearing the SPEN   bit of the RCSTAx register which resets the EUSART.
        // why not ! mais c'est peut etre un peu trop VIRULENT !
         RCSTA2.SPEN=0;
         _asm nop;
        RCSTA2.SPEN=1;
        _asm nop;
      }
      if ((c2==13) || (i2 >=16))   // terminaison par CR  ou LF
      {
        UART2_DataReady=1;
        buffer2[i2]=0 ;
        c2=0;Index2=i2;
        i2=0;
         RC2IE_bit=0 ;   // pour blocage reception
       }
        else
       {
          buffer2[i2]=c2;
          i2++;
          Index2=i2;
       }
    }

   #ifdef USB_Terminal
    USB_Interrupt_Proc();
  #endif
}

void Interrup_LowLevel() iv 0x0018 ics ICS_AUTO 
{
 #ifdef With_TMR1
  //   ====  IT Timer1  =============
  if((TMR1IE_bit==1) && (TMR1IF_bit==1))
  {
      // TMR1IE_bit=0;  // interdit interrupt
      Cpt1++;
      #ifdef OSCILLATEUR_INTERNE
      if (Cpt1>1)
       {  // TXREG2='$';  // pour debugging sur UART1
          Cpt1=0;
          Flag_Timer1=1;
          TMR1ON_bit=0; // stop timer
      }
      #else
       if (Cpt1>25)
       {
          //TXREG2='$';  // pour debugging sur UART1
          Cpt1=0;
          Flag_Timer1=1;
          TMR1ON_bit=0; // stop timer
      }
      #endif
      TMR1IF_bit=0; // Raz Flag
  }
  #endif
}


 #ifdef USB_Terminal
void CRLF_HID()
{
  *(&writebuff)=13;
  *(&writebuff+1)=10;
  *(&writebuff+2)=0;
  while(!HID_Write(&writebuff,64));
 }
 #endif

void RAZ_UART2()
{
      RC2IE_bit=0 ;
      for (i2=0;i2<MAXLEN2;i2++) buffer2[i2]=0;
      Index2=0;
     // i2=0;
      c2=RCREG2;
      c2=0;
      UART2_DataReady=0;
      Flag_data_OK=0;
      RC2IE_bit=1 ;
}

 
void CRLF2()
{
 UART2_Write(CR);
 UART2_Write(LF);
}

void UART2_Write_CText(const char *t)
{
  while (*t)
  {
   //while (TXSTA2.TRMT == 0);
   // UART2_Write(*txt++);
   if (UART_Remappable_Tx_Idle() == 1) 
   {
    UART_Remappable_Write(*t);
    t++;
   }
  }
}

unsigned char  UART2_Assign_To_PPS(void)
{
// Mapping I/O pour UART2  sur RD7 et RD6
// rp_num: Remappable pin number. Consult the appropriate datasheet for adequate values.
// input_output: Sets requested pin to be used as an input or output.
// funct_name: Selects internal MCU module for usage.
// return :
// 0 - if peripheral pin mapping wasn't successful.
// 255 - if peripheral pin mapping was successful.
unsigned char T,T1;
T1=0;
T=0;
Unlock_IOLOCK();
T=PPS_Mapping_NoLock(22, _INPUT, _RX2_DT2); // Set pin 22 to  maps RX2/DT2 Input
if (T==255)T1++;
T=PPS_Mapping_NoLock(23, _OUTPUT, _TX2_CK2);// Set pin 23 to  EUSART2 Async TX output
if(T==255) T1++;
Lock_IOLOCK();
return (T1);
}

unsigned char check_device(unsigned char dev_address)
{
char Etat,k;
strConstRamCpy(txt,"Test Presence Device  l'adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART2_Write_Text(txt);
I2C2_Start();
if(I2C2_Wr(dev_address)!=0 )
 {
  UART2_Write_CText(" Non Trouv !");
  Etat=0;
 }
 else
 {
  UART2_Write_CText(" present .. OK");
  Etat=1;
  }
I2C2_Stop();
 CRLF2();
 return Etat;
}

void Init_Timer0()
{
 //Timer0// at FOSC=48MHz Prescaler 1:32; TMR0 Preload = 18660; Actual Interrupt Time : 125 mS
 //Prescaler 1:128; TMR0 Preload = 18660; Actual Interrupt Time : 500 ms
 //Prescaler 1:256; TMR0 Preload = 18660; Actual Interrupt Time : 1000 ms
 // Timer0 ON, mode 16 bits , Internal FOSC 48MHz  ,Prescaler used by TMR0 ,precaler=1/256
 // T0CON         = 0x86;
  T08BIT_bit=0;
  T0CS_bit=0;
  PSA_bit=0;
  T0PS2_bit=1;    // div 256 => 1 seconde
  T0PS1_bit=1;
  T0PS0_bit=1;
  TMR0H         = 0x48;      // 18660
  TMR0L         = 0xE4;
  TMR0ON_bit=1;
  TMR0IE_bit= 0;
  //GIE_bit    = 1;
}

void Init_Timer1(void)
{
 TMR1CS0_bit=0;  // clock source= Fosc/4
 TMR1CS1_bit=0;  //
 TMR1ON_bit=0;   // Stop timer1
 T1CKPS1_bit=1;  // prescaler =1/8
 T1CKPS0_bit=1;
 RD16_bit=1;
 T1OSCEN_bit=0; // Secondary Oscillator Disabled
 #ifdef OSCILLATEUR_INTERNE
 // 4Mhz
  TMR1H = 0x0B;      // 3035
  TMR1L = 0xDB;
 #else
//  at 48MHz  28036 => 6D84  prescaler =8    25mS
//  TMR1H= 0x6D; // hi 28036;
//  TMR1L =0x84 ; // Lo 28036;
//  at 48MHz  5535 => 150F  prescaler =8    40mS
  TMR1H = 0x15;      // 5535
  TMR1L = 0x9F;
  #endif
  //----
//  TMR1IP_bit=1;    // set High priority for Timer1
  TMR1IP_bit=0;      // set Low priority for Timer1
  IPEN_bit = 1;      // 0= High Priority only   1= Enable High & Low  interrupt priority model.
  TMR1IF_bit=0;      // raz flag interrupt
  PEIE_bit = 1;    // enable interupt Peripheriques
  Flag_Timer1=0;
  Cpt1=0;             // 25 for 1 second
  TMR1ON_bit=1;     // desactive Timer1
  TMR1IE_bit=1;      // Enable Interrupt Timer1
}


void Init_Hardware()
{
  ANCON0 = 0xFB;       // Default all pins to digital except AN2 analog
  ANCON1 = 0x1F;
  PORTE=0;
  LATE=0;
  TRISE.REPU=0;   // 0 = All PORTE pull-ups are disabled     1 = PORTE pull-ups are enabled for any
  DS18B20_Sensor1_Direction=1;
  //PCFG<7:0>: Analog Port Configuration bits (AN7-AN0)
  //  1 = Pin configured as a digital port
  // 0 = Pin configured as an analog channel  digital input disabled and reads 0
  ANA_RA2_Direction=1;
  CM1CON=0x07;
  // hardware sur la carte Click
  T1_Direction = 1;         // Set direction for buttons
  T2_Direction = 1;
  LD1_Direction = 0;        // Set direction for LEDS
  LD2_Direction = 0;
}
#ifdef With_ADC12
float Mesure_Temperature_Filtree()
 {
  float fx;
 // EA2=ADC_Read(2);    //   activer si l'acquisition n'est pas dja faite dans le main program
  Table_EA2[Nbval & 0x0007]=EA2;
  Nbval++;
  // moyenne glissante arithmetique sur 8 valeurs
  Somme_EA2=0;
  for (i=0;i<8;i++) Somme_EA2= Somme_EA2 + Table_EA2[i];
  fx=(float)Somme_EA2 * 0.0099792; // 327 div (8*4096.0);  LM35DZ 10mV/V
  #ifdef LM335
     fx=fx-273.0;    // offset 273,0K
  #endif
  return fx;
}

void Init_ADC()
{
// Manual ADC Init
//Configured AN2 as an analog channel   (12bits via confog bits)
ADCON1.ADFM=1; // Resulst format 1= Right justified
ADCON1.ADCAL=0; // Normal A/D conversion operation
ADCON1.ACQT2=0b111; // Acquition time 7 = 20TAD 2 = 4TAD 1=2TAD
ADCON1.ADCS2=0b110; // Clock conversion bits 6= FOSC/64 2=FOSC/32
// ADCON0
ADCON0.VCFG0 =0; // Vref+ = AVdd
ADCON0.VCFG1 =0; // Vref- = AVss
ADCON0.CHS3=0b0010; // Select ADC chan
ADCON0.ADON =1;  // ADC enable
}
#endif

#ifdef With_DS18B20
unsigned char * Mesure_Temper_DS18B20(void)
{
  unsigned char j0, j1,j2,j3,j4,j5,j6,j7,j8,j9,tmp_sign;
  float res;
  char *txt="                ";
  // Nota : L1 is an signed long global varaible , used ito the main
 // sonde sur entree PORT RE0
 // mesure temperature DS18B20
     Drapeaux.First_Run=1;
     i=Ow_Reset(DS18B20_1) ;
     Ow_Write(DS18B20_1,0xCC);  // envoi pulse de reset Etat bas 480S
     Ow_Write(DS18B20_1,0x44); // lance le debut de conversion
     Delay_ms(750) ;           // delai necessaire en resolution 12 bits
     i = Ow_Reset(DS18B20_1);
     Ow_Write(DS18B20_1,0xCC);   // saute lecture du code 64 bits en ROM (si 1 seul DS18B20)
     Ow_Write(DS18B20_1,0xBE);  // Demande de lecture RAM des 9 octets
     j1 = Ow_Read(DS18B20_1);
     // for debugging
     //ByteToStr(j1,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j2 = Ow_Read(DS18B20_1);
     // for debugging
     //ByteToStr(j2,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     if (Drapeaux.First_Run==1)
     {
     // lecture des 9 registre 1 seule fois
     // 5em byte=127 => resolution=0,0625 12 bits
     j3 = Ow_Read(DS18B20_1);
     j4 = Ow_Read(DS18B20_1);
     j5 = Ow_Read(DS18B20_1);
     j6 = Ow_Read(DS18B20_1);
     j7 = Ow_Read(DS18B20_1);
     j8 = Ow_Read(DS18B20_1);
     j9 = Ow_Read(DS18B20_1);
     Drapeaux.First_Run=0;
     }
     i = Ow_Reset(DS18B20_1); // aborte, termine la lecture avant la fin
     j0=j2 & 0xF0;
     if (j0==0xF0) // test bit de signe
       {
       tmp_sign = '-';  // negative value not tested .. to hot outside !waiting some snow & cool Weather
       j1= 0xFF- j1;        // complement  2 +1  sur LSB seulement
       j1= j1 + 1;
       j2= 0xFF-j2 ;    // complement  2
       }
     else
       tmp_sign = '+' ;
     // from data sheet &  //http://daniel.menesplier.free.fr/Doc/BUS%201%20WIRE.pdf     page 9
     // reconstitue la partie entiere repartie sur les 2 premiers bytes RAM
     res=(float)((j2 & 0x07)<<4) ;
     // L1 signed long declar en global
     
          res=(float)((j2 & 0x07)<<4) ;
     // L1 long declar en global
     L1=0;
     L1= (j2 & 0x07) << 4;
     L1=L1 + ((j1 & 0xF0)>>4);
     L1=L1*1000;        // par 10 mille si on veut une resolution au 1/10em (0,0625)
     L1=  L1+ ((j1 & 0x0F)* 62);
     res=res + (float)((j1 & 0xF0)>>4) ;
     // Rajoute la partie decimale code sur 4 bits LSB de j1 , donc 0  15 => 16 etats
     // avec pas=0,0625 , soit 1/16em de degre
     res= res  + (float)(j1 & 0x0F)*0.0625 ;
     f1=res;   // f1 float declar en global !
     fltToa (res,txt+1,4) ;  // transforme en ascii
     *(txt)=tmp_sign;
     if (tmp_sign=='-') L1=-L1;
  return txt;    // pointeur sur le TEXTE representant la mesure
}
#endif

char * Decimal_less_9_999_to_Ascii( unsigned int k)
{  
// en entree  unsigned int de 0  9999  maxi
// virgule fictive sur 3 decimales
// en sortie pointer sur chaine de caractere representant 9,999
char CRam[5];
    CRam[0] = (k/1000) + 48; // extrctten thousands digit
    CRam[1] =',' ;
    CRam[2] = (k/100)%10 + 48; //extract hundreds digit
    CRam[3] = (k/10)%10 + 48; //extract tens digit
    CRam[4]=  k%10 + 48; // Extract ones digit
    CRam[5]=0;
  return CRam;
}

char * SignedLong32bits_to_Ascii_3Decimales( signed long L1)
 {
 //en Entree Entier long 32 bits non signes  L1= -99 999 9999   + 99 999 999
 //en  sortie : pointer sur table 99999,999 maxi  sans signe, avec effacement des zero inutiles
 // cadrage  droite sur 9 caracteres
 // Virgule fictive =separateur 3 decimales
    int Signe, i;
    char CRam3[9];// par economie on pourrait declarer une table globale unique pour toutes les fonctions semblables
    if (  L1 <0 )
    {

        L1= 0xFFFFFFFF -L1 +1;
        L1 = L1 & 0x7FFFFFFF;

       Signe=1;

       }
       else
       Signe=0;
    CRam3[1] = (L1/1000000) + 48; // extrait  Million
    CRam3[2] = (L1/100000)%10 + 48; // extrait  Million
     CRam3[3] = (L1/10000)%10 + 48; // extrait centaines de milliers
      CRam3[4] = (L1/1000)%10 + 48; // extrait dizaines de Milliers
       CRam3[5] =',' ;
       CRam3[6] = (L1/100)%10 + 48; // extrait Milliers
         CRam3[7] = (L1/10)%10 + 48;  // extrait dizaines
           CRam3[8] = L1%10 + 48; // recupere Unites
   CRam3[9]=0;
    for (i=1;i<4;i++)
    {
       if (CRam3[i]=='0') CRam3[i]=32; else break;
    }
    i--;
    if (Signe==1)CRam3[i-1]='-'; else CRam3[i-1]='+';
    if (i>0) CRam3[0]=32;
   return CRam3 ;
   }



void main()
{

  #ifdef OSCILLATEUR_INTERNE
  //FOSC=8MHz
  OSCCON.B6=1;
  OSCCON.B5=1;
  OSCCON.B4=1;
  /*
  // FOSC=4MHz
  OSCCON.B6=1;
  OSCCON.B5=1;
  OSCCON.B4=0;
  */
  // postscaled internal FOS
  OSCCON.B1=1;
  OSCCON.B0=1;

  OSCTUNE.PLLEN=0; // disable PLL
  OSCTUNE.B7=1;  // 31KHz from 8MHz INTOSC
  
#endif

  Init_Hardware();
  LD1=0;
  LD2=0;

  txt=&TEXTE[0];
  Etat= UART2_Assign_To_PPS() ;
  if (Etat==2) Drapeaux.PPS=1; else Drapeaux.PPS=0;
   #ifdef OSCILLATEUR_INTERNE
   UART2_Init(19200);    // at 4MHz  or 19200 at 8Mhz
  #else
   UART2_Init(115200);  // at 48MHz
   #endif
  Delay_ms(200);


  TEXTE[0]=0;
  Index2=0;
  buffer2[0]=0;
  UART2_DataReady=0;
  c2=RCREG2;
  txt=&TEXTE[0];
  
  UART2_Write(CLS);
  Delay_ms(1000);
  CRLF2();
  
  I2C2_Init(400000);

   // verif presence du LCD sur le bus I2C
   LD2=0;
   LCD_ADR=Device_LCD_ADR; // 0x74
   check_device(LCD_ADR)  ;  // 4E   A0=1 A1=1 A2=1
   LD2=1;

    UART2_Write_CText("Projet:"Project"\r\n");
   
    i= LCD2119_Init();
    LCD_CLS();
    strConstRamCpy(txt,"Click 18F47J53  ");
    LCD_Write_Text(1,1,txt);
    UART2_Write_Text(txt); CRLF2();
    strConstRamCpy(txt,"Ver: "Version);
    LCD_Write_Text(2,1,txt);
    UART2_Write_Text(txt);CRLF2();
    Delay_ms(2000);
    
   if (Drapeaux.PPS)
   {
      strConstRamCpy(txt,"Init PPS for UART2 :\r\n");
      UART2_Write_Text(txt);
   }
   if (Drapeaux.PPS)
    LCD_Write_CText(1,1,"PPS -> UART2 OK ");
    else
    LCD_Write_CText(1,1,"Bad Init  UART2 ");
    Delay_ms(2000);

  #ifdef TEST_FOSC
  Freq = Clock_kHz();
  UART2_Write_CText(" Fosc =");
  LongWordToStr(Freq, txt) ;
  UART2_Write_Text(txt);
  UART2_Write_CText(" KHz\r\n");
  UART2_Write_CText(" Check delay de 5000mS entre # et @\r\n");
  UART2_Write('#');  CRLF2();
  Delay_ms(5000);
  UART2_Write('@');  CRLF2();
  #endif
  
  RAZ_UART2();

    #ifdef With_DS18B20
   // Onewire reset signal
   if ( Ow_Reset(DS18B20_1)==0)  // &PORTE, 0
   {
     UART2_Write_CText("DS18B20 device present..sur pin RE0 ..Ok \r\n");
     LCD_Write_CText(1,1," Mes. OWS DS18B20");
      }
      else
      {
      UART2_Write_CText("pas trouv le DS18B20 \r\n");
   }
   Delay_ms(1000);
   #endif
    
    UART2_Write_CText("Mesure Temper. LM335 via ADC 12bits sur  RA2\r\n");

   #ifdef EXTRA_char
   //do
   //{
    LCD_CLS();
    LCD_Write_CText(1,1,"Cree car Degre  ");
    //Cree_8_cars_CGRAM() ;
    Cree_DegreC()  ;
    //Cree_Euro();
    /*
    LCD_RAZ_Ligne(2);
    for (i=0;i<16;i++)
    {
     // CGRAM Char
     LCD_Write_CGRAM_Chr(i)  ;
     Delay_ms(100);
     }
    Delay_ms(4000);
   }while(1);
   */
   #endif

   LCD_CLS();
   Drapeaux.First_Run=1;
   txt   = "Temp DS18B20 :  " ;
   LCD_Write_Text(1, 1, txt);

   
   UART2_Write_CText("Version perso from scratch .. resolution 0,0625C \r\n");

     i=Ow_Reset(DS18B20_1) ;
     Ow_Write(DS18B20_1,0xCC);  // envoi pulse de reset Etat bas 480S
     Ow_Write(DS18B20_1,0x44); // lance le debut de conversion
     Delay_ms(750) ;           // delai necessaire en resolution 12 bits
     i = Ow_Reset(DS18B20_1);
     Ow_Write(DS18B20_1,0xCC);   // saute lecture du code 64 bits en ROM (si 1 seul DS18B20)
     Ow_Write(DS18B20_1,0xBE);  // Demande de lecture RAM des 9 octets
     j1 = Ow_Read(DS18B20_1); 
     // for debugging
     ByteToStr(j1,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j2 = Ow_Read(DS18B20_1);
     // for debugging
     ByteToStr(j2,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     if (Drapeaux.First_Run==1)
     {
     // lecture des 9 registre 1 seule fois
     // 5em byte=127 => resolution=0,0625 12 bits
     // optional Lecture et affichage sur terminal des autres contenu de registre
     j3 = Ow_Read(DS18B20_1);  ByteToStr(j3,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j4 = Ow_Read(DS18B20_1);  ByteToStr(j4,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j5 = Ow_Read(DS18B20_1);  ByteToStr(j5,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j6 = Ow_Read(DS18B20_1);  ByteToStr(j6,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j7 = Ow_Read(DS18B20_1);  ByteToStr(j7,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j8 = Ow_Read(DS18B20_1);  ByteToStr(j8,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     j9 = Ow_Read(DS18B20_1);  ByteToStr(j9,CRam1);UART2_Write_Text(CRam1);UART2_Write(TAB);
     Drapeaux.First_Run=0;
     }
     i = Ow_Reset(DS18B20_1); // aborte, termine la lecture avant la fin
      j0= j2 & 0x80;
     if (j2==0x80) // test bit de signe
       {
       tmp_sign = '-';  // negative value not tested .. to hot outside !waiting some snow & cool Weather
       j1= 0xFF- j1;        // complement  2
       j1=j1+1;
       j2= 0xFF-j2;
       }
     else
       tmp_sign = '+' ;
     // voir data sheet &  //http://daniel.menesplier.free.fr/Doc/BUS%201%20WIRE.pdf     page 9
     // reconstitue la partie entiere repartie sur les 2 premiers bytes RAM
     res=(float)((j2 & 0x07)<<4) ;
     res=res + (float)((j1 & 0xF0)>>4) ;
     // Rajoute la partie decimale code sur 4 bits LSB de j1 , donc 0  15 => 16 etats
     // avec pas=0,0625 , soit 1/16em de degre
     res= res  + (float)(j1 & 0x0F)*0.0625 ;
     fltToa (res,txt,3) ;  // transforme en ascii
     // debugging
     UART2_Write_Text(txt);
     CRLF2();

     LCD_Write_Text(2,2,txt);
     LCD_Write_Chr_at(2,1,tmp_sign);
     LCD_Write_Chr_at(2, 10,' ');
     LCD_Write_CGRAM_Chr(0);
     Delay_ms(3500);

   LCD_CLS();
   txt=&TEXTE[0];
   
   #ifdef With_ADC12
   ADC_Init();
   LD2=0;
   LCD_Write_CText(1,1,"Mes. EA2 12 bits");
    #endif

   Init_Timer0();
  
  /*   suvre ....
   // RTC Clock
  // If the Timer1 oscillator will be used as the clock source
  //for the RTCC, make sure to enable it by setting  T1CON<3> (T1OSCEN
  //The selected RTC clock can
  // be brought out to the RTCC pin by the
  // RTSECSEL<1:0> bits in the PADCFG register
   RTCWREN_bit=1;
   _asm nop;
   RTCCFG.RTCEN=1;
   _asm   movlb 0x0F ;//RTCCFG is banked
   _asm   bcf INTCON, GIE_bit //;Disable interrupts
   _asm   movlw 0x55
   _asm   movwf EECON2
   _asm   movlw 0xAA
   _asm movwf EECON2
   _asm bsf RTCCFG,RTCWREN
   RTCSYNC_bit=1;
   RTCPTR0_bit=0;
   RTCPTR1_bit=0;
   RTCOE_bit=1;  // enable sortie clock
   RTCCAL=0;    // maxi +508 clock/minute   mini -512 clock  /minute
   RTSECSEL1_bit=1;  //source clock is selected for the RTCC pin (pin can be INTRC
   RTSECSEL0_bit=0;  //  or T1OSC, depending on theRTCOSC (CONFIG3L<1>) setting)
   
   ALRMCFG.ALRMEN=1;
   ALRMCFG.CHIME=0;
   ALRMCFG.AMASK0=0b0011; // every minute
   ALRMRPT=0x02;   //Alarm Repeat Counter Value bits
  /*
   YEAR=0x15;
   MONTGH=0x12;
   DAY=0x27
   WKDY=6; // WDAY<2:0>: Binary Coded Decimal 0=duimanche  to 6=Samedi
   HOURS=0x13;
   MINUTES=0x58;
   SEONDS=0x58;
 */
 
   RAZ_UART2();
   //RCON.IPEN=0;  // si IPEN_bit=0  high Priority mode for all , pas de LOW prioritt
   IPEN_bit=1; // high Priority mode + Low Priority mode
   IPR1.TMR1IP=0; // Low priority for Timer1
   PEIE_bit = 1; // Enable Peripheral interrupt
   GIE_bit = 1; // Enable Global interrupt

   LD2=0;
   Nbval=0;
   // ====================  BOUCLE PRINCIPALE  ======================
   
   while(1)
   {
    Init_Timer1();
    txt=&TEXTE[0];

    #ifdef With_ADC12
    strConstRamCpy(txt,"LM=");
    k=strlen(txt);
    EA2=ADC_Read(2);  
    f1=(float)EA2 * 0.0007983;// car 3,27V alim   0.008056640 <= 3.30 div 4096.0;
    f2=Mesure_Temperature_Filtree() ;
     sprintf(txt,"LM=%2.3f %3.3f",f1,f2);
   // ou
   /*
    strcat(txt+k,Decimal_less_9_999_to_Ascii((unsigned int)( f1*1000.0)));
    strcat(txt," ");
    k=strlen(txt);
    //strcat(txt+k,Virgule2Asc(f2));
    strcat(txt+k, Virgule2Asc_2decim(f2));
   */
    LCD_RAZ_Ligne(1);
    LCD_Write_Text(1,1,txt);
    LCD_Write_CGRAM_Chr(0) ;
    sprintf(txt,"EA2= % 5d ou %3.3f volts ou %3.3fC filtre  ",EA2,f1,f2);
    UART2_Write_Text(txt);  
    #endif
    
    #ifdef With_DS18B20
    //--- Mesure, Format and display result on Lcd
    txt=&TEXTE[0];
    UART2_Write_CText(" DS18B20(txt): ");
    UART2_Write_Text(Mesure_Temper_DS18B20());   // re-actualise aussi f1 et L1
      // affiche Temperature DS18B20 sur 9 caracteres
    UART2_Write_CText(" Signed Long 3 dec ");
    // pour Test via terminal
    // strcpy(CRam1,SignedLong32bits_to_Ascii_3Decimales(L2));
     strcpy(CRam1,SignedLong32bits_to_Ascii_3Decimales(L1));
    UART2_Write_Text (CRam1);
    LCD_Write_CText(2,1,"DS18B=");
    LCD_Write_Text(2,7,CRam1); LCD_Write_CGRAM_Chr(0)  ;
    #endif

    // --  UART2_Write_CText("Attente Reception UART2... \r\n");
    if(UART2_DataReady==2)  RAZ_UART2();
    if(UART2_DataReady==1)
    {
      CRLF2();
     UART2_Write_Text(buffer2);
     CRLF2();
      p2=strstr(buffer2,"LD2 ON");
      if (p2>0)
      {
         LD2=1;
         UART2_Write_CText("LED2 ON \r\n");
         p2=0;
      }
      p2=strstr(buffer2,"LD2 OFF");
      if (p2>0)
      {
         LD2=0;
         UART2_Write_CText("LD2 OFF \r\n");
         p2= 0;
      }
       p2=strstr(buffer2,"L2=");
      if (p2>0)
      {
         L2= atol(buffer2+3);
         LongToStr(L2 , CRam1);
         UART2_Write_CText("L2= "); UART2_Write_Text(CRam1);CRLF2();
         p2=0;
      }
      
    RAZ_UART2();  // re-init buffer2 et interrupt RX UART2
    CRLF2();
    }
    
   CRLF2();
   // delay de bouckle until 1 seconde atteinte
   while( Flag_Timer1==0);
   LD1=!LD1;
  }// while(1);
 }
 
 /*

Test Presence Device  l'adresse : 116 present .. OK
Projet:18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi
Click 18F47J53
Ver: 01-01-2016
Init PPS for UART2 :
 Fosc =      4000 KHz
 Check delay de 5000mS entre # et @
#
@
DS18B20 device present..sur pin RE0 ..Ok

 Version perso from scratch .. resolution 0,0625C
 91          1         75         70        127        255         12         16          7        21.687
Mesure ADC 12bits sur  RA2
EA2= 1,705  1.374EA2=  1705 ou 1.374 volts ou 15.387C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 2,166  1.745EA2=  2166 ou 1.745 volts ou 15.769C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 1,782  1.436EA2=  1782 ou 1.436 volts ou 15.369C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 2,180  1.756EA2=  2180 ou 1.756 volts ou 15.763C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 1,785  1.438EA2=  1785 ou 1.438 volts ou 15.366C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 2,182  1.758EA2=  2182 ou 1.758 volts ou 15.763C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 1,785  1.438EA2=  1785 ou 1.438 volts ou 15.368C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 2,180  1.756EA2=  2180 ou 1.756 volts ou 15.765C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 1,784  1.437EA2=  1784 ou 1.437 volts ou 15.844C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 2,179  1.756EA2=  2179 ou 1.756 volts ou 15.857C filtre   DS18B20 (txt) : +21.6875  long 4 decimales:   21,6875
EA2= 1,783  1.436EA2=  1783 ou 1.436 volts ou 15.858C filtre   DS18B20 (txt) : +21.7500  long 4 decimales:   21,7500
EA2= 2,179  1.756EA2=  2179 ou 1.756 volts ou 15.857C filtre   DS18B20 (txt) : +21.8125  long 4 decimales:   21,8125
EA2= 1,783  1.436EA2=  1783 ou 1.436 volts ou 15.855C filtre   DS18B20 (txt) : +21.8125  long 4 decimales:   21,8125
EA2= 2,182  1.758EA2=  2182 ou 1.758 volts ou 15.855C filtre   DS18B20 (txt) : +21.8750  long 4 decimales:   21,8750
EA2= 1,785  1.438EA2=  1785 ou 1.438 volts ou 15.855C filtre   DS18B20 (txt) : +21.9375  long 4 decimales:   21,9375


17:21:02.718> <0>
17:21:02.781> Device at adresse : 116 found OK
17:21:02.843> Projet:18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi
17:21:03.656> Click 18F47J53
17:21:03.718> Ver: 01-01-2016
17:21:05.718> Init PPS for UART2 :
17:21:07.718>
17:21:07.781>  Version perso from scratch .. resolution 0,0625C
17:21:08.593>  73          1         75         70        127        255         12         16        213        20.562
17:21:11.156> DS18B20 device present..sur pin RE0 ..Ok
17:21:11.218> Mesure ADC 12bits sur  RA2
17:21:12.156> EA2= 1,694  1.365EA2=  1694 ou 1.365 volts ou 36.466C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:13.218> EA2= 2,168  1.747EA2=  2168 ou 1.747 volts ou 38.378C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:14.218> EA2= 1,784  1.437EA2=  1784 ou 1.437 volts ou 40.162C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:15.218> EA2= 2,183  1.759EA2=  2183 ou 1.759 volts ou 42.025C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:16.281> EA2= 1,787  1.440EA2=  1787 ou 1.440 volts ou 40.464C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:17.281> EA2= 2,185  1.760EA2=  2185 ou 1.760 volts ou 41.305C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:18.281> EA2= 1,789  1.441EA2=  1789 ou 1.441 volts ou 13.590C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:19.281> EA2= 2,186  1.761EA2=  2186 ou 1.761 volts ou 15.776C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:20.343> EA2= 1,791  1.443EA2=  1791 ou 1.443 volts ou 15.873C filtre   DS18B20 (txt) : +20.5625 use of float: 20.5625 use of long:    55,625
17:21:21.343> EA2= 2,186  1.761E

0 1 mikroCPIC1618.exe -MSF -DBG -pP18F47J53 -C -O11111114 -fo48 -N"C:\_MikroC\_MesProjets_MikroC\_18F47J53_LCD_UART2_I2C2_DS18B20\18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_18F47J53_LCD_UART2_I2C2_DS18B20\" -SP"C:\_MikroC\_MesProjets_MikroC\common\" -SP"D:\_MasterPageWeb\common\" -IP"C:\_MikroC\_MesProjets_MikroC\_18F47J53_LCD_UART2_I2C2_DS18B20\" "18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_CMath.mcl" "__Lib_Conversions.mcl" "__Lib_Sprintf.mcl" "__Lib_Button.mcl" "__Lib_OneWire.mcl" "__Lib_ADC_xJ11.mcl" "__Lib_I2C_b45d01.mcl" "__Lib_UART_c67.mcl" "__Lib_PPS_4xJ53.mcl" "__Lib_UART_Remappable.mcl" "__Lib_USB_genHID_P18FJ53.mcl"
0 1139 Available RAM: 3739 [bytes], Available ROM: 131064 [bytes]
85 1354  warning: "/*" within comment       /*  MRPT=0x02;   //Alarm Repeat Counter Value bits  OSC (CONFIG3L<1>) setting)    ats  page 9  Weather  semblables C:\_MikroC\_MesProjets_MikroC\_18F47J53_LCD_UART2_I2C2_DS18B20\18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
0 122 Compilation Started 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
0 1004 interrupt handler (interrupt at 0x0008) 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
0 1004 interrupt handler (Interrup_LowLevel at 0x0018) 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
957 123 Compiled Successfully 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
63 1164 Variable 'j' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
381 1164 Variable 'T' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
493 1164 Variable 'fx' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j3' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j4' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j5' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j6' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j7' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j8' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
523 1164 Variable 'j9' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
524 1164 Variable 'res' has been eliminated by optimizer 18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160101.c
0 127 All files Compiled in 125 ms
0 1144 Used RAM (bytes): 539 (14%)  Free RAM (bytes): 3200 (86%) Used RAM (bytes): 539 (14%)  Free RAM (bytes): 3200 (86%)
0 1144 Used ROM (bytes): 28458 (22%)  Free ROM (bytes): 102606 (78%) Used ROM (bytes): 28458 (22%)  Free ROM (bytes): 102606 (78%)
0 125 Project Linked Successfully 18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi
0 128 Linked in 109 ms
0 129 Project '18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi' completed: 266 ms
0 103 Finished successfully: 02 janv. 2016, 10:42:57 18F47J53_LCD_UART2_I2C2_ADC_DS18B20_2016.mcppi

*/