


// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source)
{
  while(*source) *(dest++) = *(source++) ;
  *dest = 0 ;    // terminateur
}

void fltToa (double x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
int ie, i, k, ndig;
double y;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;                // a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;                                // a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
}




//http://www.fantaspic.fr/viewtopic.php?f=10&t=137
char * VirguleAscii(float ChiffreDeci)
{
unsigned int e=0;
unsigned int d=0;
int k;
char PointeurTab[17];    // modif size !
char PointerDecimales[8];
char *p;
char *q;
p=PointeurTab;
for (k=0;k<17;k++) PointeurTab[k]=0;
q=PointerDecimales;
e=(signed int)floor(ChiffreDeci);
d=fabs(ChiffreDeci-e)  *1000;
d=floor(d);
IntToStr(e,p);
k=strlen(p);
*(p+k)=','; //0x2C;
*(p+k+1)=0;
WordToStr(d,q);
q=Ltrim(q);
while(strlen(q)<3)
{
strcat(q,"0");
}
strcat(p,q);
return p;

}


// +99.999  -99.999
char * Virgule2Asc(float ChiffreDeci)
{ int i;
  unsigned int e=0;
  unsigned int d=0;
  char PointeurTab[17];    // modif size !
  char *p;
  p=PointeurTab;
  for (k=0;k<17;k++) PointeurTab[k]=0;
  e=(int)ChiffreDeci;                                 // partie entire
  d=(int)((ChiffreDeci-(float)e)*1000.0);
  if (ChiffreDeci<0.0)
     PointeurTab[0] ='-';
       else
       PointeurTab[0]= ' ';

  PointeurTab[1] = e/100 + 48;
  PointeurTab[2] = (e/10)%10 + 48;
  PointeurTab[3] = (e%10) + 48;
  for (i=1;i<3;i++)
  { 
  if (PointeurTab[i]=='0')
      PointeurTab[i]=' ';
      else
      break;
  };
  PointeurTab[4]=',';
  k=(d/100) ; PointeurTab[5] = k + 48;
  d=d-k*100;
  k=d/10;   PointeurTab[6] = k + 48;
  d=d-k*10;
  PointeurTab[7] = d + 48;
  PointeurTab[8] = 0;
return p;
}


// +99.99  -99.99
char * Virgule2Asc_2decim(float ChiffreDeci)
{ int i;
  unsigned int e=0;
  unsigned int d=0;
  char PointeurTab[17];    // modif size !
  char *p;
  p=PointeurTab;
  for (k=0;k<17;k++) PointeurTab[k]=0;
  e=(int)ChiffreDeci;                                 // partie entire
  d=(int)((ChiffreDeci-(float)e)*100.0);
  if (ChiffreDeci<0.0)
     PointeurTab[0] ='-';
       else
       PointeurTab[0]= ' ';

  PointeurTab[1] = e/100 + 48;
  PointeurTab[2] = (e/10)%10 + 48;
  PointeurTab[3] = (e%10) + 48;
  for (i=1;i<3;i++)
  {
  if (PointeurTab[i]=='0')
      PointeurTab[i]=' ';
      else
      break;
  };
  PointeurTab[4]=',';
  k=(d/10) ; PointeurTab[5] = k + 48;
  d=d-k*10;
  k=d;   PointeurTab[6] = k + 48;
  PointeurTab[7] = 0;
return p;
}