
// specific 18F47J53

extern unsigned int Flag_Timer1;
extern unsigned int Cpt1;


void Init_Timer1(void)
{

 TMR1CS0_bit=0;  // clock source= Fosc/4
 TMR1CS1_bit=0;  //
 TMR1ON_bit=0;   // Stop timer1
 T1CKPS1_bit=1;  // prescaler =1/8
 T1CKPS0_bit=1;
 RD16_bit=1;
 T1OSCEN_bit=0; // Secondary Oscillator Disabled

//  at 48MHz  28036 => 6D84  prescaler =8    25mS
//  TMR1H= 0x6D; // hi 28036;
//  TMR1L =0x84 ; // Lo 28036;
//  at 48MHz  5535 => 150F  prescaler =8    40mS
  TMR1H = 0x15;      // 5535
  TMR1L   = 0x9F;
  //----
  TMR1IP_bit=1;      // set hihh priority for Timer1
  IPEN_bit = 1;      // Enable High interrupt priority model.
  TMR1IF_bit=0;      // raz flag interrupt
  PEIE_bit = 1;    // enable interupt Peripheriques
  Flag_Timer1=0;
  Cpt1=0;             // 40 for 1 second
  TMR1ON_bit=1;     // desactive Timer1
  TMR1IE_bit=1;      // Enable Interrupt Timer1
  GIE_bit = 1;     // Enaable global interrupt
}