#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 141 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;





sbit ANA_RA2 at PORTA.B2;
sbit ANA_RA2_Direction at TRISA2_bit;

sbit DS18B20_Sensor1 at PORTE.B0;
sbit DS18B20_Sensor1_Direction at TRISE.B0;



char TEXTE[120];
char CRam1[32];
char *txt;
char *p;



volatile unsigned char buffer2[ 128 ] ;
volatile unsigned int Index2=0;
volatile unsigned int i2=0;
volatile unsigned int UART2_DataReady=0;
volatile unsigned int Flag_data_OK ;
volatile unsigned char c2=0;
unsigned char *p2;

volatile unsigned int Flag_Timer0;
volatile unsigned int Flag_Timer1;
volatile unsigned int Cpt1;
char oldstate1 = 0, oldstate2 = 0;
unsigned char Example_State = 0;
char count;
unsigned int i,j,k,l;
unsigned int M;
int Etat;
unsigned char LCD_ADR;
signed long L1,L2;
unsigned long Freq;
float f1, f2 ;
unsigned int EA2, temp_res;
unsigned int Table_EA2[8];
unsigned int Nbval;
unsigned Somme_EA2;
static unsigned char c3,c4;



const unsigned short TEMP_RESOLUTION = 12;
char *text = "000.00000";
char Tp[]="000.000000";
float Tf;


unsigned char j0,j1, j2, j3, j4, j5, j6, j7, j8,j9 ;
unsigned char tmp_sign,drp;
float res;
#line 217 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
volatile struct chbits {
 unsigned FrameErr:1;
 unsigned Over:1;
 unsigned Dialogue:1;
 unsigned FLT:1;
 unsigned PPS:1;
 unsigned Sommeil:1;

 unsigned Mesure:1;
 unsigned First_Run:1;
 }Drapeaux ;
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f47j53_lcd_uart2_i2c2_ds18b20/string_routines.h"




void strConstRamCpy(char *dest, const char *source)
{
 while(*source) *(dest++) = *(source++) ;
 *dest = 0 ;
}

void fltToa (double x, unsigned char *str,char precision)
{


int ie, i, k, ndig;
double y;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;

if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }
 ndig += ie;


for (y = i = 1; i < ndig; i++)
 y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
*str = '\0';
}





char * VirguleAscii(float ChiffreDeci)
{
unsigned int e=0;
unsigned int d=0;
int k;
char PointeurTab[17];
char PointerDecimales[8];
char *p;
char *q;
p=PointeurTab;
for (k=0;k<17;k++) PointeurTab[k]=0;
q=PointerDecimales;
e=(signed int)floor(ChiffreDeci);
d=fabs(ChiffreDeci-e) *1000;
d=floor(d);
IntToStr(e,p);
k=strlen(p);
*(p+k)=',';
*(p+k+1)=0;
WordToStr(d,q);
q=Ltrim(q);
while(strlen(q)<3)
{
strcat(q,"0");
}
strcat(p,q);
return p;

}



char * Virgule2Asc(float ChiffreDeci)
{ int i;
 unsigned int e=0;
 unsigned int d=0;
 char PointeurTab[17];
 char *p;
 p=PointeurTab;
 for (k=0;k<17;k++) PointeurTab[k]=0;
 e=(int)ChiffreDeci;
 d=(int)((ChiffreDeci-(float)e)*1000.0);
 if (ChiffreDeci<0.0)
 PointeurTab[0] ='-';
 else
 PointeurTab[0]= ' ';

 PointeurTab[1] = e/100 + 48;
 PointeurTab[2] = (e/10)%10 + 48;
 PointeurTab[3] = (e%10) + 48;
 for (i=1;i<3;i++)
 {
 if (PointeurTab[i]=='0')
 PointeurTab[i]=' ';
 else
 break;
 };
 PointeurTab[4]=',';
 k=(d/100) ; PointeurTab[5] = k + 48;
 d=d-k*100;
 k=d/10; PointeurTab[6] = k + 48;
 d=d-k*10;
 PointeurTab[7] = d + 48;
 PointeurTab[8] = 0;
return p;
}



char * Virgule2Asc_2decim(float ChiffreDeci)
{ int i;
 unsigned int e=0;
 unsigned int d=0;
 char PointeurTab[17];
 char *p;
 p=PointeurTab;
 for (k=0;k<17;k++) PointeurTab[k]=0;
 e=(int)ChiffreDeci;
 d=(int)((ChiffreDeci-(float)e)*100.0);
 if (ChiffreDeci<0.0)
 PointeurTab[0] ='-';
 else
 PointeurTab[0]= ' ';

 PointeurTab[1] = e/100 + 48;
 PointeurTab[2] = (e/10)%10 + 48;
 PointeurTab[3] = (e%10) + 48;
 for (i=1;i<3;i++)
 {
 if (PointeurTab[i]=='0')
 PointeurTab[i]=' ';
 else
 break;
 };
 PointeurTab[4]=',';
 k=(d/10) ; PointeurTab[5] = k + 48;
 d=d-k*10;
 k=d; PointeurTab[6] = k + 48;
 PointeurTab[7] = 0;
return p;
}
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f47j53_lcd_uart2_i2c2_ds18b20/lcd2119_i2c2_routines.h"
#line 18 "c:/_mikroc/_mesprojets_mikroc/_18f47j53_lcd_uart2_i2c2_ds18b20/lcd2119_i2c2_routines.h"
extern char LCD_ADR;
extern void Decompile_byte(unsigned char un);
extern char *txt;

void LCD_CLS(void);
void LCD_Clear(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_at(int Ligne,int Col,char c1) ;
void LCD_Write_Chr(unsigned char cx);
void LCD_Write_Text(unsigned int Ligne,unsigned char * t1);
void LCD_Write_CText(unsigned int Ligne,unsigned int col,const char * t1);

void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void) ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);





void LCD_Write_Chr(unsigned char cx)
{
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 I2C2_Wr( 0x80 + cx );
 I2C2_Stop();
}

void LCD_Write_CGRAM_Chr(unsigned char cx)
{
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 I2C2_Wr( 0x00 + cx );
 I2C2_Stop();
}



void LCD_CLS()
{

LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}


void LCD_Clear()
{

int j;
I2C2_Start();
j=I2C2_Wr(LCD_ADR);
j=I2C2_Wr(0x00);
j=I2C2_Wr(0x24);
j=I2C2_Wr(0x06);
j=I2C2_Wr(0x02);
j=I2C2_Wr(0x01);
j=I2C2_Wr(0x40);
I2C2_Stop();
}

int LCD2119_Init(void)
{

int j,k;
k=0;
Delay_ms(500);
I2C2_Start();
j=I2C2_Wr(LCD_ADR);
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2C2_Wr(0x00);
if (j>0) return k;
k++;
I2C2_Wr(0x24);
I2C2_Wr(0x0C);
I2C2_Wr(0x06);
I2C2_Wr(0x25);

I2C2_Wr(0x06);
I2C2_Wr(0x11);
I2C2_Wr(0x42);

I2C2_Wr(0x96);
j=I2C2_Wr(0x24);
if (j>0) return k;
k++;
j=I2C2_Wr(0x0C);
if (j>0) return k;
k++;
j=I2C2_Wr(0x06);
if (j>0) return k;
k++;
j=I2C2_Wr(0x02);
if (j>0) return k;
k++;


j=I2C2_Wr(0x01);
if (j>0) return k;
Delay_ms(100);
I2C2_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{
int i;
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);
 I2C2_Wr(0x02);
 switch (L)
 {
 case 1:
 I2C2_Wr(0x80);
 break;
 case 2:
 I2C2_Wr(0xC0);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 for (i=0;i<39;i++)
 {
 I2C2_Wr(0x80+32);
 }

 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);

 switch (L)
 {
 case 1:
 I2C2_Wr(0x80);
 break;
 case 2:
 I2C2_Wr(0xC0);
 break;
 default:
 break ;
 }
 I2C2_Stop();
}

void LCD_Write_CText(unsigned int Ligne,unsigned int col,const unsigned char * t1)
 {
 char TT[17];
 int i;
 strConstRamCpy(TT,t1);
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 i=0;
 while(*(t1))
 {
 I2C2_Wr(0x80+*(t1));
 t1++;
 i++;
 if (i>16) break;
 }
 I2C2_Stop();
}

void LCD_Write_Chr_at(int Ligne,int col,unsigned char c1)
{


 I2C2_Start() ;
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 I2C2_Wr( 0x80 + c1 );
 Delay_ms(10);
 I2C1_Stop();
 }


void LCD_Write_Text(unsigned int Ligne,unsigned int col,unsigned char * t1)
{

 int i;
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);
 i=0;
 while(*(t1))
 {
 I2C2_Wr(0x80+*(t1));
 t1++;
 i++;
 if (i>16) break;
 }
 I2C2_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
 LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);
 I2C2_Wr(Cde);
 I2C2_Stop();
}

void LCD_Gauche()
{
 LCD_Cde(0x010);
 }



void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
 I2C2_Start();
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x00);

 I2C2_Wr(0x40);

 I2C2_Repeated_Start() ;
 I2C2_Wr(LCD_ADR);
 I2C2_Wr(0x40);



I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
#line 342 "c:/_mikroc/_mesprojets_mikroc/_18f47j53_lcd_uart2_i2c2_ds18b20/lcd2119_i2c2_routines.h"
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0011111);
I2C2_Wr(0b0010001);
I2C2_Wr(0b0011111);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);

I2C2_Wr(0x06);
I2C2_Wr(0x09);
I2C2_Wr(0x08);
I2C2_Wr(0x1E);
I2C2_Wr(0x1E);
I2C2_Wr(0x08);
I2C2_Wr(0x09);
I2C2_Wr(0x06);


I2C2_Wr(0x07);
I2C2_Wr(0x05);
I2C2_Wr(0x07);
I2C2_Wr(0x00);
I2C2_Wr(0x0E);
I2C2_Wr(0x10);
I2C2_Wr(0x10);
I2C2_Wr(0x0E);

I2C2_Stop();
}


void Cree_Euro()
{
I2C2_Start();

I2C2_Wr(LCD_ADR);


I2C2_Wr(0x00);


I2C2_Wr(0x06);


I2C2_Wr(0x40);


 I2C2_Repeated_Start() ;
I2C2_Wr(LCD_ADR);

I2C2_Wr(0x40);



I2C2_Wr(0x06);
I2C2_Wr(0x09);
I2C2_Wr(0x08);
I2C2_Wr(0x1E);
I2C2_Wr(0x1E);
I2C2_Wr(0x08);
I2C2_Wr(0x09);
I2C2_Wr(0x06);
I2C2_Stop();
}


void Cree_DegreC()
{
I2C2_Start();
I2C2_Wr(LCD_ADR);
I2C2_Wr(0x00);
I2C2_Wr(0x06);
I2C2_Wr(0x40);
I2C2_Repeated_Start() ;
I2C2_Wr(LCD_ADR);
I2C2_Wr(0x40);
I2C2_Wr(0x07);
I2C2_Wr(0x05);
I2C2_Wr(0x07);
I2C2_Wr(0x00);
I2C2_Wr(0x0E);
I2C2_Wr(0x10);
I2C2_Wr(0x10);
I2C2_Wr(0x0E);
I2C2_Stop();
}
#line 249 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
void InitTimer0(void);
unsigned char UART2_Assign_To_PPS(void) ;
void Init_Hardware(void);
void CRLF2(void);
void UART2_Write_CText(const char *txt);
unsigned char UART2_Assign_To_PPS(void);
void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char * Mesure_Temper_DS18B20(void);
char * SignedLong32bits_to_Ascii_3Decimales( signed long L1);

char * Virgule2Asc_2decim(float ChiffreDeci);




void interrupt() iv 0x0008 ics ICS_AUTO
{
 static i2=0;
 if (TMR0IF_bit)
 {
 TXREG2='?';
 TMR0IF_bit=0;
 }
 if(RC2IF_bit==1)
 {
 c2 = RCREG2 ;
 if(OERR_bit)
 {
 TXREG2='@';
 CREN2_bit = 0;
 _asm nop;
 CREN2_bit = 1;
 _asm nop;
 }
 while(FERR2_bit)
 {
 TXREG2='*';
 RCREG2=0;
 _asm nop;
 c2 = RCREG2;


 RCSTA2.SPEN=0;
 _asm nop;
 RCSTA2.SPEN=1;
 _asm nop;
 }
 if ((c2==13) || (i2 >=16))
 {
 UART2_DataReady=1;
 buffer2[i2]=0 ;
 c2=0;Index2=i2;
 i2=0;
 RC2IE_bit=0 ;
 }
 else
 {
 buffer2[i2]=c2;
 i2++;
 Index2=i2;
 }
 }
#line 315 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
}

void Interrup_LowLevel() iv 0x0018 ics ICS_AUTO
{


 if((TMR1IE_bit==1) && (TMR1IF_bit==1))
 {

 Cpt1++;

 if (Cpt1>1)
 {
 Cpt1=0;
 Flag_Timer1=1;
 TMR1ON_bit=0;
 }
#line 341 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 TMR1IF_bit=0;
 }

}
#line 357 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
void RAZ_UART2()
{
 RC2IE_bit=0 ;
 for (i2=0;i2< 128 ;i2++) buffer2[i2]=0;
 Index2=0;

 c2=RCREG2;
 c2=0;
 UART2_DataReady=0;
 Flag_data_OK=0;
 RC2IE_bit=1 ;
}


void CRLF2()
{
  UART_Remappable_Write ( 13 );
  UART_Remappable_Write ( 10 );
}

void UART2_Write_CText(const char *t)
{
 while (*t)
 {


 if (UART_Remappable_Tx_Idle() == 1)
 {
 UART_Remappable_Write(*t);
 t++;
 }
 }
}

unsigned char UART2_Assign_To_PPS(void)
{







unsigned char T,T1;
T1=0;
T=0;
Unlock_IOLOCK();
T=PPS_Mapping_NoLock(22, _INPUT, _RX2_DT2);
if (T==255)T1++;
T=PPS_Mapping_NoLock(23, _OUTPUT, _TX2_CK2);
if(T==255) T1++;
Lock_IOLOCK();
return (T1);
}

unsigned char check_device(unsigned char dev_address)
{
char Etat,k;
strConstRamCpy(txt,"Test Presence Device  l'adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
 UART_Remappable_Write_Text (txt);
I2C2_Start();
if(I2C2_Wr(dev_address)!=0 )
 {
 UART2_Write_CText(" Non Trouv !");
 Etat=0;
 }
 else
 {
 UART2_Write_CText(" present .. OK");
 Etat=1;
 }
I2C2_Stop();
 CRLF2();
 return Etat;
}

void Init_Timer0()
{





 T08BIT_bit=0;
 T0CS_bit=0;
 PSA_bit=0;
 T0PS2_bit=1;
 T0PS1_bit=1;
 T0PS0_bit=1;
 TMR0H = 0x48;
 TMR0L = 0xE4;
 TMR0ON_bit=1;
 TMR0IE_bit= 0;

}

void Init_Timer1(void)
{
 TMR1CS0_bit=0;
 TMR1CS1_bit=0;
 TMR1ON_bit=0;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 RD16_bit=1;
 T1OSCEN_bit=0;


 TMR1H = 0x0B;
 TMR1L = 0xDB;
#line 479 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 TMR1IP_bit=0;
 IPEN_bit = 1;
 TMR1IF_bit=0;
 PEIE_bit = 1;
 Flag_Timer1=0;
 Cpt1=0;
 TMR1ON_bit=1;
 TMR1IE_bit=1;
}


void Init_Hardware()
{
 ANCON0 = 0xFB;
 ANCON1 = 0x1F;
 PORTE=0;
 LATE=0;
 TRISE.REPU=0;
 DS18B20_Sensor1_Direction=1;



 ANA_RA2_Direction=1;
 CM1CON=0x07;

 T1_Direction = 1;
 T2_Direction = 1;
 LD1_Direction = 0;
 LD2_Direction = 0;
}

float Mesure_Temperature_Filtree()
 {
 float fx;

 Table_EA2[Nbval & 0x0007]=EA2;
 Nbval++;

 Somme_EA2=0;
 for (i=0;i<8;i++) Somme_EA2= Somme_EA2 + Table_EA2[i];
 fx=(float)Somme_EA2 * 0.0099792;

 fx=fx-273.0;

 return fx;
}

void Init_ADC()
{


ADCON1.ADFM=1;
ADCON1.ADCAL=0;
ADCON1.ACQT2=0b111;
ADCON1.ADCS2=0b110;

ADCON0.VCFG0 =0;
ADCON0.VCFG1 =0;
ADCON0.CHS3=0b0010;
ADCON0.ADON =1;
}



unsigned char * Mesure_Temper_DS18B20(void)
{
 unsigned char j0, j1,j2,j3,j4,j5,j6,j7,j8,j9,tmp_sign;
 float res;
 char *txt="                ";



 Drapeaux.First_Run=1;
 i=Ow_Reset( &PORTE,0 ) ;
 Ow_Write( &PORTE,0 ,0xCC);
 Ow_Write( &PORTE,0 ,0x44);
 Delay_ms(750) ;
 i = Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 ,0xCC);
 Ow_Write( &PORTE,0 ,0xBE);
 j1 = Ow_Read( &PORTE,0 );


 j2 = Ow_Read( &PORTE,0 );


 if (Drapeaux.First_Run==1)
 {


 j3 = Ow_Read( &PORTE,0 );
 j4 = Ow_Read( &PORTE,0 );
 j5 = Ow_Read( &PORTE,0 );
 j6 = Ow_Read( &PORTE,0 );
 j7 = Ow_Read( &PORTE,0 );
 j8 = Ow_Read( &PORTE,0 );
 j9 = Ow_Read( &PORTE,0 );
 Drapeaux.First_Run=0;
 }
 i = Ow_Reset( &PORTE,0 );
 j0=j2 & 0xF0;
 if (j0==0xF0)
 {
 tmp_sign = '-';
 j1= 0xFF- j1;
 j1= j1 + 1;
 j2= 0xFF-j2 ;
 }
 else
 tmp_sign = '+' ;


 res=(float)((j2 & 0x07)<<4) ;


 res=(float)((j2 & 0x07)<<4) ;

 L1=0;
 L1= (j2 & 0x07) << 4;
 L1=L1 + ((j1 & 0xF0)>>4);
 L1=L1*1000;
 L1= L1+ ((j1 & 0x0F)* 62);
 res=res + (float)((j1 & 0xF0)>>4) ;


 res= res + (float)(j1 & 0x0F)*0.0625 ;
 f1=res;
 fltToa (res,txt+1,4) ;
 *(txt)=tmp_sign;
 if (tmp_sign=='-') L1=-L1;
 return txt;
}


char * Decimal_less_9_999_to_Ascii( unsigned int k)
{



char CRam[5];
 CRam[0] = (k/1000) + 48;
 CRam[1] =',' ;
 CRam[2] = (k/100)%10 + 48;
 CRam[3] = (k/10)%10 + 48;
 CRam[4]= k%10 + 48;
 CRam[5]=0;
 return CRam;
}

char * SignedLong32bits_to_Ascii_3Decimales( signed long L1)
 {




 int Signe, i;
 char CRam3[9];
 if ( L1 <0 )
 {

 L1= 0xFFFFFFFF -L1 +1;
 L1 = L1 & 0x7FFFFFFF;

 Signe=1;

 }
 else
 Signe=0;
 CRam3[1] = (L1/1000000) + 48;
 CRam3[2] = (L1/100000)%10 + 48;
 CRam3[3] = (L1/10000)%10 + 48;
 CRam3[4] = (L1/1000)%10 + 48;
 CRam3[5] =',' ;
 CRam3[6] = (L1/100)%10 + 48;
 CRam3[7] = (L1/10)%10 + 48;
 CRam3[8] = L1%10 + 48;
 CRam3[9]=0;
 for (i=1;i<4;i++)
 {
 if (CRam3[i]=='0') CRam3[i]=32; else break;
 }
 i--;
 if (Signe==1)CRam3[i-1]='-'; else CRam3[i-1]='+';
 if (i>0) CRam3[0]=32;
 return CRam3 ;
 }



void main()
{



 OSCCON.B6=1;
 OSCCON.B5=1;
 OSCCON.B4=1;
#line 683 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 OSCCON.B1=1;
 OSCCON.B0=1;

 OSCTUNE.PLLEN=0;
 OSCTUNE.B7=1;



 Init_Hardware();
 LD1=0;
 LD2=0;

 txt=&TEXTE[0];
 Etat= UART2_Assign_To_PPS() ;
 if (Etat==2) Drapeaux.PPS=1; else Drapeaux.PPS=0;

  UART_Remappable_Init (19200);
#line 703 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 Delay_ms(200);


 TEXTE[0]=0;
 Index2=0;
 buffer2[0]=0;
 UART2_DataReady=0;
 c2=RCREG2;
 txt=&TEXTE[0];

  UART_Remappable_Write ( 12 );
 Delay_ms(1000);
 CRLF2();

 I2C2_Init(400000);


 LD2=0;
 LCD_ADR= 0x74 ;
 check_device(LCD_ADR) ;
 LD2=1;

 UART2_Write_CText("Projet:" "18F47J53_UART2_LCD_I2C2_LM335_ADC12b_DS18B20_2016.mcppi" "\r\n");

 i= LCD2119_Init();
 LCD_CLS();
 strConstRamCpy(txt,"Click 18F47J53  ");
 LCD_Write_Text(1,1,txt);
  UART_Remappable_Write_Text (txt); CRLF2();
 strConstRamCpy(txt,"Ver: " "20-01-2016" );
 LCD_Write_Text(2,1,txt);
  UART_Remappable_Write_Text (txt);CRLF2();
 Delay_ms(2000);

 if (Drapeaux.PPS)
 {
 strConstRamCpy(txt,"Init PPS for UART2 :\r\n");
  UART_Remappable_Write_Text (txt);
 }
 if (Drapeaux.PPS)
 LCD_Write_CText(1,1,"PPS -> UART2 OK ");
 else
 LCD_Write_CText(1,1,"Bad Init  UART2 ");
 Delay_ms(2000);
#line 760 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 RAZ_UART2();



 if ( Ow_Reset( &PORTE,0 )==0)
 {
 UART2_Write_CText("DS18B20 device present..sur pin RE0 ..Ok \r\n");
 LCD_Write_CText(1,1," Mes. OWS DS18B20");
 }
 else
 {
 UART2_Write_CText("pas trouv le DS18B20 \r\n");
 }
 Delay_ms(1000);


 UART2_Write_CText("Mesure Temper. LM335 via ADC 12bits sur  RA2\r\n");




 LCD_CLS();
 LCD_Write_CText(1,1,"Cree car Degre  ");

 Cree_DegreC() ;
#line 799 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 LCD_CLS();
 Drapeaux.First_Run=1;
 txt = "Temp DS18B20 :  " ;
 LCD_Write_Text(1, 1, txt);


 UART2_Write_CText("Version perso from scratch .. resolution 0,0625C \r\n");

 i=Ow_Reset( &PORTE,0 ) ;
 Ow_Write( &PORTE,0 ,0xCC);
 Ow_Write( &PORTE,0 ,0x44);
 Delay_ms(750) ;
 i = Ow_Reset( &PORTE,0 );
 Ow_Write( &PORTE,0 ,0xCC);
 Ow_Write( &PORTE,0 ,0xBE);
 j1 = Ow_Read( &PORTE,0 );

 ByteToStr(j1,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j2 = Ow_Read( &PORTE,0 );

 ByteToStr(j2,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 if (Drapeaux.First_Run==1)
 {



 j3 = Ow_Read( &PORTE,0 ); ByteToStr(j3,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j4 = Ow_Read( &PORTE,0 ); ByteToStr(j4,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j5 = Ow_Read( &PORTE,0 ); ByteToStr(j5,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j6 = Ow_Read( &PORTE,0 ); ByteToStr(j6,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j7 = Ow_Read( &PORTE,0 ); ByteToStr(j7,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j8 = Ow_Read( &PORTE,0 ); ByteToStr(j8,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 j9 = Ow_Read( &PORTE,0 ); ByteToStr(j9,CRam1); UART_Remappable_Write_Text (CRam1); UART_Remappable_Write ( 9 );
 Drapeaux.First_Run=0;
 }
 i = Ow_Reset( &PORTE,0 );
 j0= j2 & 0x80;
 if (j2==0x80)
 {
 tmp_sign = '-';
 j1= 0xFF- j1;
 j1=j1+1;
 j2= 0xFF-j2;
 }
 else
 tmp_sign = '+' ;


 res=(float)((j2 & 0x07)<<4) ;
 res=res + (float)((j1 & 0xF0)>>4) ;


 res= res + (float)(j1 & 0x0F)*0.0625 ;
 fltToa (res,txt,3) ;

  UART_Remappable_Write_Text (txt);
 CRLF2();

 LCD_Write_Text(2,2,txt);
 LCD_Write_Chr_at(2,1,tmp_sign);
 LCD_Write_Chr_at(2, 10,' ');
 LCD_Write_CGRAM_Chr(0);
 Delay_ms(3500);

 LCD_CLS();
 txt=&TEXTE[0];


 ADC_Init();
 LD2=0;
 LCD_Write_CText(1,1,"Mes. EA2 12 bits");


 Init_Timer0();
#line 913 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 RAZ_UART2();

 IPEN_bit=1;
 IPR1.TMR1IP=0;
 PEIE_bit = 1;
 GIE_bit = 1;

 LD2=0;
 Nbval=0;


 while(1)
 {
 Init_Timer1();
 txt=&TEXTE[0];


 strConstRamCpy(txt,"LM=");
 k=strlen(txt);
 EA2=ADC_Read(2);
 f1=(float)EA2 * 0.0007983;
 f2=Mesure_Temperature_Filtree() ;
 sprintf(txt,"LM=%2.3f %3.3f",f1,f2);
#line 944 "C:/_MikroC/_MesProjets_MikroC/_18F47J53_LCD_UART2_I2C2_DS18B20/18F47J53_Tests_UART2_LCD_I2C2_ADC12b_DS18B20_160120.c"
 LCD_RAZ_Ligne(1);
 LCD_Write_Text(1,1,txt);
 LCD_Write_CGRAM_Chr(0) ;
 sprintf(txt,"EA2= % 5d ou %3.3f volts ou %3.3fC filtre  ",EA2,f1,f2);
  UART_Remappable_Write_Text (txt);




 txt=&TEXTE[0];
 UART2_Write_CText(" DS18B20(txt): ");
  UART_Remappable_Write_Text (Mesure_Temper_DS18B20());

 UART2_Write_CText(" Signed Long 3 dec ");


 strcpy(CRam1,SignedLong32bits_to_Ascii_3Decimales(L1));
  UART_Remappable_Write_Text  (CRam1);
 LCD_Write_CText(2,1,"DS18B=");
 LCD_Write_Text(2,7,CRam1); LCD_Write_CGRAM_Chr(0) ;



 if(UART2_DataReady==2) RAZ_UART2();
 if(UART2_DataReady==1)
 {
 CRLF2();
  UART_Remappable_Write_Text (buffer2);
 CRLF2();
 p2=strstr(buffer2,"LD2 ON");
 if (p2>0)
 {
 LD2=1;
 UART2_Write_CText("LED2 ON \r\n");
 p2=0;
 }
 p2=strstr(buffer2,"LD2 OFF");
 if (p2>0)
 {
 LD2=0;
 UART2_Write_CText("LD2 OFF \r\n");
 p2= 0;
 }
 p2=strstr(buffer2,"L2=");
 if (p2>0)
 {
 L2= atol(buffer2+3);
 LongToStr(L2 , CRam1);
 UART2_Write_CText("L2= ");  UART_Remappable_Write_Text (CRam1);CRLF2();
 p2=0;
 }

 RAZ_UART2();
 CRLF2();
 }

 CRLF2();

 while( Flag_Timer1==0);
 LD1=!LD1;
 }
 }
